% casteljau08.m
% fd, 17 octobre 2006, 04 mars 2025
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   clear ; format long

printf('casteljau08 : courbe de Bezier de Castejau de degre 5 avec poles confondus\n') ;


n=1 ; nn=6 ; 
pt = zeros(nn , 2) ; 
hold off ;

m=60 %% 150 ,
dth = 1 / m ; 

x1=1; y1=0; x2=0; y2=1;  x3=.5; y3=2; x4=1; y4=1.5; x5=0 ; y5=0 ; 



pt(1:1,1:1)=0; pt(2:2,1:1)=x1; pt(3:3,1)=x2; pt(4,1)=x3;
pt(1:1,2:2)=0; pt(2:2,2:2)=y1; pt(3:3,2)=y2; pt(4,2)=y3;
pt(5,1)=x4;  pt(5,2)=y4;
pt(6,1)=x5;  pt(6,2)=y5;

%%%  plot(pt(1:nn,1),pt(1:nn,2),'*k;noeuds;')
plot(pt(1:nn,1),pt(1:nn,2),'k;polygone de controle;') ; hold on 
axis ( [ -.1, 1.1 , -.1 , 2.1 ]) ;
delete (findobj ("tag", "legend")) 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
printf('premiere generation de sommets : 5 segments\n') ;
pp1s1 = zeros(2,m+1) ; pp1s2 = zeros(2,m+1) ; pp1s3 = zeros(2,m+1) ; pp1s4 = zeros(2,m+1) ;
pp1s5 = zeros(2,m+1) ;

for k=1:m+1;
theta = (k-1)*dth ; 
pp1s1(:,k) =  (1-theta)*pt(1,:) + theta*pt(2,:) ; 
pp1s2(:,k) =  (1-theta)*pt(2,:) + theta*pt(3,:) ;  
pp1s3(:,k) =  (1-theta)*pt(3,:) + theta*pt(4,:) ;
pp1s4(:,k) =  (1-theta)*pt(4,:) + theta*pt(5,:) ;
pp1s5(:,k) =  (1-theta)*pt(5,:) + theta*pt(6,:) ;
end

plot(pp1s1(1,:) , pp1s1(2,:) , '*r;segment 1;'); pause (.1)
plot(pp1s2(1,:) , pp1s2(2,:) , '*b;segment 2;');  pause (.1) 
plot(pp1s3(1,:) , pp1s3(2,:) , '*m;segment 3;');  pause (.1) 
plot(pp1s4(1,:) , pp1s4(2,:) , '*g;segment 4;');  pause (.1)  
plot(pp1s5(1,:) , pp1s5(2,:) , '*c;segment 5;'); 
delete (findobj ("tag", "legend"))
title ('courbe de Bezier de Casteljau de degre 5 : premiere generation de sommets') ;
print('08a-courbe-degre-5', '-djpg','-S891,630'); 
pause (2); hold off 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
printf('seconde generation de sommets : 4 polynomes de degre 2\n') ;
pp2s1 = zeros(2,m+1) ; pp2s2 = zeros(2,m+1) ; pp2s3 = zeros(2,m+1) ; pp2s4 = zeros(2,m+1) ;

for k=1:m+1;
theta = (k-1)*dth ; 
pp2s1(:,k) =  (1-theta)*pp1s1(:,k) + theta*pp1s2(:,k) ;
pp2s2(:,k) =  (1-theta)*pp1s2(:,k) + theta*pp1s3(:,k) ;
pp2s3(:,k) =  (1-theta)*pp1s3(:,k) + theta*pp1s4(:,k) ;
pp2s4(:,k) =  (1-theta)*pp1s4(:,k) + theta*pp1s5(:,k) ;
end

plot(pt(1:nn,1),pt(1:nn,2),'k;polygone de controle;') ; hold on 
axis ( [ -.1, 1.1 , -.1 , 2.1 ]) ;

plot(pp1s1(1,:) , pp1s1(2,:) , '+k;segment 1;'); pause (.1)
plot(pp1s2(1,:) , pp1s2(2,:) , '+k;segment 2;');  pause (.1) 
plot(pp1s3(1,:) , pp1s3(2,:) , '+k;segment 3;');  pause (.1) 
plot(pp1s4(1,:) , pp1s4(2,:) , '+k;segment 4;');  pause (.1)  
plot(pp1s5(1,:) , pp1s5(2,:) , '+k;segment 5;');  pause (.1)
plot(pp2s1(1,:) , pp2s1(2,:) , '*r;P2 1;'); pause (.1)
plot(pp2s2(1,:) , pp2s2(2,:) , '*b;P2 2;'); pause (.1)
plot(pp2s3(1,:) , pp2s3(2,:) , '*m;P2 3;'); pause (.1)
delete (findobj ("tag", "legend"))
plot(pp2s4(1,:) , pp2s4(2,:) , '*g;P2 4;'); 
delete (findobj ("tag", "legend"))

title ('courbe de Bezier de Casteljau de degre 5 : seconde generation de sommets') ;
print('08b-courbe-degre-5', '-djpg','-S891,630'); 
 pause (2)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
printf('troisieme generation de sommets : 3 polynomes de degre 3\n') ;
pp3s1 = zeros(2,m+1) ; pp3s2 = zeros(2,m+1) ; pp3s3 = zeros(2,m+1) ; 

for k=1:m+1;
theta = (k-1)*dth ; 
pp3s1(:,k) =  (1-theta)*pp2s1(:,k) + theta*pp2s2(:,k) ;
pp3s2(:,k) =  (1-theta)*pp2s2(:,k) + theta*pp2s3(:,k) ;
pp3s3(:,k) =  (1-theta)*pp2s3(:,k) + theta*pp2s4(:,k) ;
end 

hold off 
plot(pt(1:nn,1),pt(1:nn,2),'k;polygone de controle;') ; hold on 
axis ( [ -.1, 1.1 , -.1 , 2.1 ]) ; pause (.1)
plot(pp2s1(1,:) , pp2s1(2,:) , '+k;P2 1;'); pause (.1)
plot(pp2s2(1,:) , pp2s2(2,:) , '+k;P2 2;'); pause (.1)
plot(pp2s3(1,:) , pp2s3(2,:) , '+k;P2 3;'); pause (.1)
plot(pp2s4(1,:) , pp2s4(2,:) , '+k;P2 4;'); pause (.1)
plot(pp3s1(1,:) , pp3s1(2,:) , '*r;P3 1;'); pause (.1)
plot(pp3s2(1,:) , pp3s2(2,:) , '*b;P3 2;'); pause (.1)
plot(pp3s3(1,:) , pp3s3(2,:) , '*m;P3 3;'); 
delete (findobj ("tag", "legend"))

title ('courbe de Bezier de Casteljau de degre 5 : troisieme generation de sommets') ;
print('08c-courbe-degre-5', '-djpg','-S891,630'); 
 pause (2)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
printf('quatrieme generation de sommets : 2 polynomes de degre 4\n') ;
pp4s1 = zeros(2,m+1) ; pp4s2 = zeros(2,m+1) ;  

for k=1:m+1;
theta = (k-1)*dth ; 
pp4s1(:,k) =  (1-theta)*pp3s1(:,k) + theta*pp3s2(:,k) ;
pp4s2(:,k) =  (1-theta)*pp3s2(:,k) + theta*pp3s3(:,k) ;
end 

hold off 
plot(pt(1:nn,1),pt(1:nn,2),'k;polygone de controle;') ; hold on 
axis ( [ -.1, 1.1 , -.1 , 2.1 ]) ; pause (.1)
plot(pp3s1(1,:) , pp3s1(2,:) , '+k;P3 1;'); pause (.1)
plot(pp3s2(1,:) , pp3s2(2,:) , '+k;P3 2;'); pause (.1)
plot(pp3s3(1,:) , pp3s3(2,:) , '+k;P3 3;'); pause (.1)
plot(pp4s1(1,:) , pp4s1(2,:) , '*r;P4 1;'); pause (.1)
plot(pp4s2(1,:) , pp4s2(2,:) , '*b;P4 2;'); 
delete (findobj ("tag", "legend"))
title ('courbe de Bezier de Casteljau de degre 5 : quatrieme generation de sommets') ;
print('08d-courbe-degre-5', '-djpg','-S891,630'); 
pause(2) 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
printf('cinquieme generation de sommets : un polynome de degre 5\n') ;
pp5s1 = zeros(2,m+1) ;

for k=1:m+1;
theta = (k-1)*dth ; 
pp5s1(:,k) =  (1-theta)*pp4s1(:,k) + theta*pp4s2(:,k) ; end ; 

hold off 
plot(pt(1:nn,1),pt(1:nn,2),'k;polygone de controle;') ; hold on 
axis ( [ -.1, 1.1 , -.1 , 2.1 ]) ; pause (.1)
plot(pp4s1(1,:) , pp4s1(2,:) , '+k;P4 1;'); pause (.1)
plot(pp4s2(1,:) , pp4s2(2,:) , '+k;P4 2;'); pause (.1)
plot(pp5s1(1,:) , pp5s1(2,:) , '*r;P5 1;'); 

delete (findobj ("tag", "legend"))
title ('courbe de Bezier de Casteljau de degre 5 : cinquieme generation de sommets') ;
print('08e-courbe-degre-5', '-djpg','-S891,630'); 

 


